/***************************************************************************
 *   Copyright 2011 by Eugeni Kozhanov <eugeni.kozhanov@rosalab.ru>        *
 *                                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef SEPARATOR_H
#define SEPARATOR_H

#include <QAction>
#include <KMenu>
#include <QGraphicsView>
#include <KFileItem>
#include <KDirLister>

#include <Plasma/Applet>


class RosaSeparator : public Plasma::Applet
{
    Q_OBJECT
    public:
        RosaSeparator(QObject *parent, const QVariantList &args);
        ~RosaSeparator();
	void paintInterface(QPainter *p,
                const QStyleOptionGraphicsItem *option,
                const QRect& contentsRect);
        void init();
        //void constraintsEvent(Plasma::Constraints constraints);

    public slots:
        void updateSizes(void);
        
    private:
        Plasma::Svg m_svg;
        float m_svgRatio;
};

K_EXPORT_PLASMA_APPLET(RosaSeparator, RosaSeparator)

#endif
